package ch.ethz.inf.sct.uts.examples

import ch.ethz.inf.sct.uts.annotation._

object RuntimePlayground {
  def main(args: Array[String]) {
    (new RTActivities @rep).run
    println(ch.ethz.inf.sct.uts.rt.UTSRuntime.handler.info)
  }
}

class RTActivities {
  def run {
    println("Begin...")
    
    val a : RTClass0 @rep = new (RTClass0 @rep)
    a.sayHello
    val b = new RTClass1(1)
    b.sayHello
    val c = new RTClass2(a)
    c.sayHello
    val d = new RTClass3(1)
    d.sayHello
    val e = new RTClass3[RTClass0 @rep](a)
    e.sayHello
    
    val f = {
      val g = new RTClass0
      println("Do something else, like, modifying some hashtable...")
      g
    }
    f.sayHello
    
    println("Done.")
  }
}

class RTClassBase {
  def sayHello {
    println("Hello from the "+this.getClass.getName+" instance!")
  }
}

class RTClass0 extends RTClassBase

class RTClass1(val v: Int) extends RTClassBase

class RTClass2(val v: RTClass0 @any) extends RTClassBase

class RTClass3[T](val v: T) extends RTClassBase