package ch.ethz.inf.sct.uts.examples.static

import ch.ethz.inf.sct.uts.annotation._

class TryCatchFinally {
  
  // Ok
  def fun0 : Boolean = {
    try {
    	exfun
      true
    }
    catch {
      case ex: Exception => false 
    }
    finally {
   		println("Finally.")
    }
  }

  // Not ok - catch-block result does not subtype method result
  def fun1 : TryCatchFinally = {
    try {
      exfun
      new TryCatchFinally @peer
    }
    catch {
      case ex1: Exception            => new TryCatchFinally @rep
      case ex2: NullPointerException => val tmp : TryCatchFinally @any = new TryCatchFinally; tmp
    }
  }

  //Not ok - try-block result does not subtype method result
  def fun2 : TryCatchFinally = {
    try {
      exfun
      new TryCatchFinally @rep
    }
    catch {
      case ex: Exception => new TryCatchFinally @peer
    }
  }
  
  def exfun {
    throw new Exception
  }
}
